<?php
class controller_addon_zadarma_mailer extends addon {
    function action_index($addon) {
        if (isset($_POST['zadarma-widget-call'])) {
            $params = unserialize($addon['params']);
            $from = 'Пользователь сайта '.SITE_NAME;
            $from_email = $params['from_email']; 
            $to = $params['to_email'];
            $subject = 'Заказ звонка на сайте '.SITE_NAME;
            $message = 'На сайте '.SITE_URL.' заказан обратный звонок на номер '.$_POST['phone'].'.';
            if (isset($_POST['date'])) $message .= ' Пользователь указал, что ждет звонка '.$_POST['date'].'.';
            $message .= ' Заявка получена '.date('d.m.Y в H:i').'.';
            $this->mailto($to, $subject, $message, array(), $from, $from_email);
            die();
        } else {
            $this->page['head'] = $this->add_js_file(SITE_URL . '/modules/addons/zadarma_mailer/zadarma_mailer.js');
            return $this->page;
        }
    }

    public function action_activate() {
        return $this->settings('activate', array('from_email' => 'robot@example.com', 'to_email' => 'info@example.com'));
    }
    
    public function action_settings($addon) {
        $params = unserialize($addon['params']);
        return $this->settings('edit_settings', $params);
    }
    
    private function settings($submit_name, $params) {
        $errors = array();
        if (isset($_POST[$submit_name])) {

            $params['from_email'] = $_POST['from_email'];
            $params['to_email'] = $_POST['to_email'];

            if ($params['to_email'] == '') $errors[] = 'Нужно указать адрес получателя уведомлений.';

            if (empty($errors)) {
                $this->page['params'] = serialize($params);
            } else {
                unset($_POST[$submit_name]);
            }
        }

        $this->data['errors'] = $errors;
        $this->data['params'] = $params;
        $this->page['html'] = $this->load_view();
        return $this->page;
    }

    private function mailto($to, $subject, $message, $attach=Array(), $from="Робот", $fromAddr) {

        $mb_internal_encoding = mb_internal_encoding();
        mb_internal_encoding('UTF-8');

        $headers = "Date: ".date("r")."\r\n";
        $headers.= "From: =?UTF-8?B?".base64_encode($from)."?= <".$fromAddr.">\r\n";
        $headers.= "MIME-Version: 1.0\r\n";

        $subject = "=?UTF-8?B?".base64_encode($subject)."?=";
        if (strpos($message, '<body')) $msgType = "text/html"; else $msgType = "text/plain";
        if (is_string($attach)) $attach = Array($attach);
        $files = Array();
        foreach ($attach as $path) if (file_exists($path)) $files[] = $path;

        if ($files) {
            $boundary = md5(time());
            $headers .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\r\n";

            $body  = "\r\n--$boundary\r\n"; 
            $body .= "Content-Type: $msgType; charset=UTF-8\r\n";
            $body .= "Content-Transfer-Encoding: 8bit\r\n";
            $body .= "\r\n";
            $body .= $message;

            foreach ($files as $path) {
                $filename = mb_substr($path, mb_strrpos($path, '/'));
                $body .= "\r\n--$boundary\r\n"; 
                $body .= "Content-Type: application/octet-stream\r\n";  
                $body .= "Content-Transfer-Encoding: base64\r\n"; 
                $body .= "Content-Disposition: attachment; filename*=UTF-8''".urlencode($filename)."\r\n"; 
                $body .= "\r\n";
                $body .= chunk_split(base64_encode(file_get_contents($path)));
            }
            
            $body .= "\r\n--$boundary--\r\n";
        
        } else {
            $headers .= "Content-Type: $msgType; charset=UTF-8\r\n";
            $headers .= "Content-Transfer-Encoding: 8bit\r\n";
            $headers .= "\r\n";
            $body = $message;
        }
        mb_internal_encoding($mb_internal_encoding);
        return mail($to, $subject, $body, $headers);
    }
}